package de.accso.flexinale.backoffice.api_contract.event;

import de.accso.flexinale.backoffice.api_contract.event.model.VorfuehrungTO;
import de.accso.flexinale.common.api.event.AbstractEvent;
import de.accso.flexinale.common.api.event.Event;
import de.accso.flexinale.common.shared_kernel.DoNotCheckInArchitectureTests;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

public abstract sealed class VorfuehrungCRUDEvent extends AbstractEvent implements Event
    permits VorfuehrungCreatedEvent, VorfuehrungUpdatedEvent, VorfuehrungDeletedEvent {

    public enum CRUD { CREATE, UPDATE, DELETE }

    @DoNotCheckInArchitectureTests
    public final VorfuehrungTO vorfuehrung;

    protected VorfuehrungCRUDEvent(final VorfuehrungTO vorfuehrung) {
        this.vorfuehrung = vorfuehrung;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        final VorfuehrungCRUDEvent that = (VorfuehrungCRUDEvent) o;

        return new EqualsBuilder().appendSuper(super.equals(o))
                .append(version(), that.version())
                .append(vorfuehrung, that.vorfuehrung).isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .appendSuper(super.hashCode()).append(vorfuehrung)
                .append(version())
                .toHashCode();
    }
}
